typedef   signed char       int8;
typedef unsigned char      uint8;
typedef   signed short      int16;
typedef unsigned short     uint16;
typedef   signed int        int32;
typedef unsigned int       uint32;
typedef   signed long long  int64;
typedef unsigned long long uint64;
typedef struct { char *data; int64 len; int64 size; } FBSTRING;
typedef int8 boolean;
struct $16__FB_ARRAYDIMTB$ {
	int64 ELEMENTS;
	int64 LBOUND;
	int64 UBOUND;
};
#define __FB_STATIC_ASSERT( expr ) extern int __$fb_structsizecheck[(expr) ? 1 : -1]
__FB_STATIC_ASSERT( sizeof( struct $16__FB_ARRAYDIMTB$ ) == 24 );
struct $8FBARRAY1IsE {
	int16* DATA;
	int16* PTR;
	int64 SIZE;
	int64 ELEMENT_LEN;
	int64 DIMENSIONS;
	int64 FLAGS;
	struct $16__FB_ARRAYDIMTB$ DIMTB[1];
};
__FB_STATIC_ASSERT( sizeof( struct $8FBARRAY1IsE ) == 72 );
void fb_PrintString( int32, FBSTRING*, int32 );
FBSTRING* fb_StrAllocTempDescZEx( uint8*, int64 );
void fb_Init( int32, uint8**, int32 );
void fb_End( int32 );
void* fopen( uint8*, uint8* );
int32 fclose( void* );
void write_gsub_spec_to_table( void*, void*, void* );
void* read_GSUB_spec_txt( uint8*, void* );

int32 main( int32 __FB_ARGC__$0, char** __FB_ARGV__$0 )
{
	int32 fb$result$0;
	__builtin_memset( &fb$result$0, 0, 4ll );
	fb_Init( __FB_ARGC__$0, (uint8**)__FB_ARGV__$0, 0 );
	label$0:;
	int16 CCODETBL$0[131073];
	__builtin_memset( (int16*)CCODETBL$0, 0, 262146ll );
	struct $8FBARRAY1IsE tmp$2$0;
	*(int16**)&tmp$2$0 = (int16*)CCODETBL$0;
	*(int16**)((uint8*)&tmp$2$0 + 8ll) = (int16*)CCODETBL$0;
	*(int64*)((uint8*)&tmp$2$0 + 16ll) = 262146ll;
	*(int64*)((uint8*)&tmp$2$0 + 24ll) = 2ll;
	*(int64*)((uint8*)&tmp$2$0 + 32ll) = 1ll;
	*(int64*)((uint8*)&tmp$2$0 + 40ll) = 49ll;
	*(int64*)((uint8*)&tmp$2$0 + 48ll) = 131073ll;
	*(int64*)((uint8*)&tmp$2$0 + 56ll) = 0ll;
	*(int64*)((uint8*)&tmp$2$0 + 64ll) = 131072ll;
	{
		int64 I$1;
		I$1 = 0ll;
		label$5:;
		{
			*(int16*)((int64)(int16*)CCODETBL$0 + (I$1 << (1ll & 63ll))) = (int16)I$1;
		}
		label$3:;
		I$1 = I$1 + 1ll;
		label$2:;
		if( I$1 <= 131071ll ) goto label$5;
		label$4:;
	}
	void* GSUBSTRUCT$0;
	void* vr$8 = read_GSUB_spec_txt( (uint8*)"gsub_table.txt", (void*)CCODETBL$0 );
	GSUBSTRUCT$0 = vr$8;
	void* FILE$0;
	__builtin_memset( &FILE$0, 0, 8ll );
	FBSTRING* vr$10 = fb_StrAllocTempDescZEx( (uint8*)"parsed gsub text", 16ll );
	fb_PrintString( 0, (FBSTRING*)vr$10, 1 );
	void* vr$11 = fopen( (uint8*)"gsub_test_out2.dat", (uint8*)"w+" );
	FILE$0 = (void*)vr$11;
	write_gsub_spec_to_table( (void*)FILE$0, GSUBSTRUCT$0, (void*)CCODETBL$0 );
	fclose( (void*)FILE$0 );
	label$1:;
	fb_End( 0 );
	return fb$result$0;
}
