const std = @import("std");
const bi = @import("builtin");

const G = struct {
  alloc:std.mem.Allocator,
  stdin:std.fs.File,
  stdout:std.fs.File,
  stderr:std.fs.File,
};
var gg:?G=null; 
export fn getg()*G{
   if(gg)|g|{return g;}
   gg=G{
	if(bi.link_libc){std.heap.c_allocator;}else{std.heap.GeneralPurposeAllocator(.{}){};},
	std.io.getStdIn(),
	std.io.getStdOut(),
	std.io.getStdErr()
   };
   return &gg;
}

pub fn getLine()!std.ArrayList(u8){
   var g=getg();
   var s = std.ArrayList(u8).init(g.alloc);
   return s;
} 
