#include <stdio.h>
#include <stdlib.h>
#include "u8.h"
int main(int argc,char **argv){
	if(argc < 2)exit(2);
	FILE *file_a = fopen(argv[1],"r");
	if(!file_a)printf("%s doesn't exist\n",argv[1]);
	char *a_inv = calloc(1,0x20000);
	int c;
	int n = 0;
	while ( EOF != (c = u8fscanch(file_a)) ) {
		if(c < 0x20000)a_inv[c] = 1;
//		u8fputch(stderr,c);
	}
	const char *blocks[] = {" ","░","▒","▓","█","·"};
	c = 0;
	int cov[16];
	int any;
	while ( c < 0x20000 ){
		any = 0;
		do {
			int d = 0, x = 0;
			while (d < 0x10){
				if (a_inv[c+d]) x++;
				d++;
			}
			if (x > 0) any = 1;
			int i = c%0x100/0x10;
			cov[i]=x*4/0x10;
			if (x > 0 && cov[i] == 0)cov[i]=5;
			c+=0x10;
		}while(c % 0x100 != 0);
		if(any){
			printf("%05x:",c-0x100);
			int i;
			for(i=0;i<16;i++)printf("%s",blocks[cov[i]]);
			printf("\n");
		}
	}
	printf("\n");
	return 0;
}
