#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "u8.h"

int main(int argc,char **argv){
	if(argc < 3){
            printf("invcmp A B");
            printf("outputs chars in B not in A");
	    exit(2);
	}
	FILE *file_a = fopen(argv[1],"r");
	FILE *file_b = fopen(argv[2],"r");
	if(!file_a)printf("%s doesn't exist\n",argv[1]);
	if(!file_b)printf("%s doesn't exist\n",argv[2]);
	int numeric = 0;
	if(argc > 3 && strchr(argv[3],'n'))numeric = 1;
	char *a_inv = calloc(1,0x20000);
	int c;
	int n = 0;
	while ( EOF != (c = u8fscanch(file_a)) ) {
		if(c < 0x20000)a_inv[c] = 1;
//		u8fputch(stderr,c);
	}
	while ( EOF != (c = u8fscanch(file_b)) ) {
		if(c < 0x20000 && a_inv[c] != 1) {
			if(numeric)printf("U%x ",c);
			else {
				if(u8apxwid(c)==0)u8putch(0x25CC);
				u8fputch(stdout,c);
			}
			if(++n % 16 == 0 )printf("\n");
		}
	}
	return 0;
}
